/*
 * Copyright 2003 - 2012 The eFaps Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Revision:        $Rev: 7483 $
 * Last Changed:    $Date: 2012-05-11 11:57:38 -0500 (Fri, 11 May 2012) $
 * Last Changed By: $Author: jan@moxter.net $
 */


package org.efaps.db.search.value;

import org.efaps.db.wrapper.SQLSelect;
import org.efaps.util.EFapsException;

/**
 * TODO comment!
 *
 * @author The eFaps Team
 * @version $Id: QSQLValue.java 7483 2012-05-11 16:57:38Z jan@moxter.net $
 */
public class QSQLValue
    extends AbstractQValue
{

    /**
     * sql statement.
     */
    private final CharSequence sql;

    /**
     * @param _sql sql
     */
    public QSQLValue(final CharSequence _sql)
    {
        this.sql = _sql;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public QSQLValue appendSQL(final SQLSelect _sql)
        throws EFapsException
    {
        _sql.addNestedSelectPart(this.sql);
        return this;
    }
}
